LeetCode hot100-67-N

https://leetcode.cn/problems/find-minimum-in-rotated-sorted-array/description/?envType=study-plan-v2\&envId=top-100-liked

java 复制代码
153. 寻找旋转排序数组中的最小值
已解答
中等
相关标签
相关企业
提示
已知一个长度为 n 的数组,预先按照升序排列,经由 1 到 n 次 旋转 后,得到输入数组。例如,原数组 nums = [0,1,2,4,5,6,7] 在变化后可能得到:
若旋转 4 次,则可以得到 [4,5,6,7,0,1,2]
若旋转 7 次,则可以得到 [0,1,2,4,5,6,7]
注意,数组 [a[0], a[1], a[2], ..., a[n-1]] 旋转一次 的结果为数组 [a[n-1], a[0], a[1], a[2], ..., a[n-2]] 。

给你一个元素值 互不相同 的数组 nums ,它原来是一个升序排列的数组,并按上述情形进行了多次旋转。请你找出并返回数组中的 最小元素 。

你必须设计一个时间复杂度为 O(log n) 的算法解决此问题。
java 复制代码
class Solution {
    public int findMin(int[] nums) {
        int l=0,r=nums.length-1;
        //int min = nums[0];
        while(l<r){
            int mid=(l+r)/2;
            // 在左边
            if(nums[mid]<nums[r]){
                r=mid;
            // 在右边
            } else{
                l=mid+1;
            }

        }
        return nums[l];
        
    }
}

为什么不能更新high = mid - 1?

想象一种情况,【4, 5, 6, 0, 1, 2, 3】这个数组右半段为0, 1, 2, 3,左半段为4,5,6, 第一次判断中点mid将落在0的位置,此时若:

令high = mid -1。你会发现出了问题,因为此时的high变成了0元素的前一位:元素6的位置!而low位置没动,新的数组变成了【4, 5, 6】,这样我们就把最小值0漏掉了。

为什么中间元素与右边元素比较,而不是与左边元素比较。解释如下

相关推荐
code斗3 小时前
Java数据结构:堆详解
java·开发语言·数据结构
Elaine3365 小时前
数据结构与算法-程序
数据结构·python·算法·计算机基础·编程基础
Persistent的粽子!6 小时前
双指针算法:最大盛水容器
c++·算法·leetcode
Logic1016 小时前
C语言/数据结构位运算题解:异或XOR找出游戏速通中的“独特初始能量值“——只出现一次的数字
c语言·数据结构·数组·位运算·时间复杂度·算法题·异或性质
Bruce_Liuxiaowei8 小时前
Python 字典默认值完全指南:从 KeyError 到 defaultdict
开发语言·数据结构·python·字典
All for pursuit.12 小时前
【二叉树-10】114.二叉树展开为链表
数据结构·c++·算法·leetcode·链表
心中有你021414 小时前
C语言埃氏筛法(素数筛选)
c语言·数据结构·算法
释厄62317 小时前
多黑洞具现论·物理/生物/金融三域显化·虚拟宇宙黑洞·奇点=0 圆圈
开发语言·数据结构·人工智能·程序人生·安全威胁分析
库玛西1 天前
攻克 408 数据结构:图论基石深度拆解(数学极值推演 + 存储内存剖析 + BFS/DFS 双核模板)
数据结构·算法·深度优先·广度优先·图搜索算法
m0_547486666 天前
《数据结构教程》全套 PPT课件2026
数据结构